#include "m_fs.h"

typedef struct _root {
    char *root;
    int mode;
    struct _root *next;
} root;

typedef struct _mapping_rule {
    pcre *match;
    char *mapping;
    struct _mapping_rule *next;
} mapping;

typedef struct _access_rule {
    unsigned int op;
    pcre *match;
    struct _access_rule *next;
} access;

/* -------------------------------------------------------------------------- */

public m_fs *fs_open_view(const char *root, int mode)
{
    m_fs *ret = NULL;

    if (! root) return NULL;

    ret = malloc(sizeof(*ret));
    if (! ret) goto _err_malloc;

    ret->_root = malloc(sizeof(*ret->_root));
    if (! ret->_root) goto _err_root;

    ret->_root->root = string_dups(root, strlen(root));
    ret->_root->mode = mode;
    ret->_root->next = NULL;

    ret->_map = NULL;
    ret->_acl = NULL;

    return ret;

_err_root:
    free(ret);
_err_malloc:
    perror(ERR(fs_open_view, malloc));
    return NULL;
}

/* -------------------------------------------------------------------------- */

public m_fs *fs_close_view(m_fs *view)
{
    return NULL;
}

/* -------------------------------------------------------------------------- */
