#include "m_request.h"

/* -------------------------------------------------------------------------- */

private m_request *request_alloc(unsigned int type, )
{
    m_request *ret = NULL;

    switch(type) {
        case REQUEST_SENDDATA:
        break;
        
        case REQUEST_SENDFILE:
        break;

        case REQUEST_RECVFILE:
        break;

        case REQUEST_SHUTDOWN:
        break;
    }

    return ret;
}

/* -------------------------------------------------------------------------- */

private m_request *request_free(m_request *req)
{
    if (! req) return NULL;

    free(req->data);
    if (req->fd != -1) close(req->fd);
    free(req);

    return NULL;
}

/* -------------------------------------------------------------------------- */
/* Request Queue implementation */
/* -------------------------------------------------------------------------- */

private inline m_work_queue *work_queue_alloc(void)
{
    return queue_alloc();
}

/* -------------------------------------------------------------------------- */

private inline m_work_queue *work_queue_free(m_work_queue *queue)
{
    return queue_free(queue);
}

/* -------------------------------------------------------------------------- */

private inline void work_queue_free_nodes(m_work_queue *queue)
{
    queue_free_nodes(queue, (void (*)(void *)) request_free);
}

/* -------------------------------------------------------------------------- */

private inline int work_queue_push(m_work_queue *queue, m_request *req)
{
    return queue_push(queue, req);
}

/* -------------------------------------------------------------------------- */

private inline int work_queue_empty(m_work_queue *queue)
{
    return queue_empty(queue);
}

/* -------------------------------------------------------------------------- */

private inline m_request *work_queue_pop(m_work_queue *queue)
{
    return queue_pop(queue);
}

/* -------------------------------------------------------------------------- */

private inline int work_queue_unpop(m_work_queue *queue, m_request *req)
{
    return queue_unpop(queue, req);
}

/* -------------------------------------------------------------------------- */
