#ifndef M_REQUEST_H

#define M_REQUEST_H

#include "m_core_def.h"
#include "m_string.h"
#include "m_queue.h"

/** @defgroup request core::request */

typedef struct m_request {
    /* public */
    unsigned int type;

    /* data */
    unsigned char *data;
    int fd;
    
    /* transfer parameters */
    size_t len;
    off_t off;

    /* in case of chunked transfers, the chunk size */
    size_t chunk;
} m_request;

typedef m_work_queue m_queue;


/* request types */
#define REQUEST_SENDFILE 0x01
#define REQUEST_RECVFILE 0x02
#define REQUEST_SENDDATA 0x04
#define REQUEST_SHUTDOWN 0x08

#endif
