#ifndef M_PORT_STD_H

#define M_PORT_STD_H

/* math.h */

#ifndef NAN
#define NAN (0.0 / 0.0)
#endif

#ifndef INF
#define INF (1e+999)
#endif

/* long long support */

#ifndef LLONG_MAX
/* Minimum and maximum values a `signed long long int' can hold.  */
#define LLONG_MAX    9223372036854775807LL
#endif

#ifndef LLONG_MIN
#define LLONG_MIN    (-LLONG_MAX - 1LL)
#endif

#ifndef ULLONG_MAX
/* Maximum value an `unsigned long long int' can hold.  (Minimum is 0.)  */
#define ULLONG_MAX   18446744073709551615ULL
#endif

/* -------------------------------------------------------------------------- */
#ifdef WIN32 /* WIN32 compatibility for common functions or keywords */
/* -------------------------------------------------------------------------- */

#ifndef inline
#define inline __inline
#endif

#ifndef snprintf
#define snprintf _snprintf
#endif

#ifndef stat
#define stat _stat
#endif

#ifndef fstat
#define fstat _fstat
#endif

#ifndef _strtoi64
    public long long strtoll(const char *nptr, char **endptr, int base);
    #define strtoull (unsigned long long) strtoll
#else
    #define strtoll _strtoi64
    #define strtoull (unsigned __int64) _strtoi64
#endif

#if defined(_MSC_VER) && (_MSC_VER < 1300)
    /* C99 booleans */
    #define bool     int
    #define true     1
    #define false    0
    /* C99 or non ANSI functions/keywords */
    #define inline   __inline
    #define snprintf _snprintf
    #define stat     _stat
    /* C99 int types */
    #define int8_t   char
    #define uint8_t  unsigned char
    #define int16_t  short
    #define uint16_t unsigned short
    #define int32_t  int
    #define uint32_t unsigned int
    #define int64_t  __int64
    #define uint64_t unsigned __int64
#endif

#define INVALID_FILE_HANDLE ((HANDLE)INVALID_HANDLE_VALUE)

/* -------------------------------------------------------------------------- */
#else
/* -------------------------------------------------------------------------- */

#if ! defined(strtoll) && defined(strtoq)
    #define strtoll strtoq
#endif

#if ! defined(strtoull) && defined(strtouq)
    #define strtoll strtouq
#endif

/* -------------------------------------------------------------------------- */
#endif
/* -------------------------------------------------------------------------- */

#endif
