#include "../m_core_def.h"

/* winegcc -g -mno-cygwin -I../ports/libpthread-win32/include -Wall -std=c99 -posix -pedantic -O2 -lmswsock ../ports/m_ports.c map.c -o map */

int main(void)
{
    char *map = NULL;

    /* create an anonymous map */
    map = mmap(
               NULL,
               strlen("hello world !") + 1,
               PROT_READ | PROT_WRITE,
               MAP_PRIVATE | MAP_ANON,
               -1,
               0
              );

    if (map == MAP_FAILED) {
        printf("** mmap failed ! **\n");
        perror(ERR(main, mmap));
        exit(EXIT_FAILURE);
    } else {
        memcpy(map, "hello world !", strlen("hello world !") + 1);
    }

    printf("%s\n", map);

    if (munmap(map, strlen("hello world !") + 1) == -1) {
        printf("** munmap failed ! **\n");
        perror(ERR(main, munmap));
        exit(EXIT_FAILURE);
    }

    /* shared memory test */
    map = shm_alloc("/sharedmem", get_page_size());

    if (! map) {
        printf("** shm_alloc failed ! **\n");
        exit(EXIT_FAILURE);
    }

    memcpy(map, "hello world !", strlen("hello world !") + 1);

    printf("-- Waiting 1 minute to let another process write"
           "in the shared memory --\n");

    sleep(60);

    printf("-- Finished waiting --\n");

    printf("shared memory content: %s\n", map);

    shm_free("/sharedmem", map, get_page_size());

    exit(EXIT_SUCCESS);
}
