#include "../m_queue.h"

/* gcc -g -Wall -std=c99 -posix -pedantic -O2 ../m_queue.c queue.c -lpthread -o queue */

/* winegcc -g -mno-cygwin -I../ports/libpthread-win32/include -Wall -std=c99 -posix -pedantic -O2 ../m_queue.c queue.c -o queue */

typedef struct _item { int data; } _item;
static m_queue *q = NULL;

static void *_push(void *dummy)
{
    _item *item = NULL; unsigned int i = 0;

    for (i = 0; i < 10; i ++)
        if ( (item = malloc(sizeof(*item))) == NULL) {
            perror(ERR(main, malloc)); exit(EXIT_FAILURE);
        } else {
            item->data = i; queue_push(q, item);
        }

    return NULL;
}

static void *_pop(void *dummy)
{
    _item *item = NULL; unsigned int i = 0;

    for (i = 0; i < 10; i ++)
        if ( (item = (_item *) queue_pop(q)) == NULL) {
            printf("MISS\n"); i --;
        } else {
            printf("%2i ", item->data); free(item);
        }
    printf("\n");

    return NULL;
}

int main(void)
{
    pthread_t push, pop;

    if ( (q = queue_alloc()) == NULL) exit(EXIT_FAILURE);

    pthread_create(& push, NULL, _push, NULL);
    pthread_create(& pop, NULL, _pop, NULL);

    pthread_join(push, NULL); pthread_join(pop, NULL);

    q = queue_free(q);

    exit(EXIT_SUCCESS);
}
