/* gcc -W -Wall -std=c99 -posix -pedantic -Os ../m_random.c randbenchmark.c -o randbenchmark */

#include "../m_random.h"

int main(void)
{
    clock_t start;
    clock_t stop;
    size_t i, j;
    unsigned long seed = 4357UL;
    m_random *r = NULL;

    printf("Testing the Mersenne Twister implementation\n");
    r = random_init();
    start = clock();
    for(i = 0; i < 300000000; i ++) j = random_uint32(r);
    stop = clock();
    r = random_fini(r);

    printf("Time elapsed = ");
    printf("%8.3f", (double)( stop - start ) / CLOCKS_PER_SEC);
    printf(" s\n");

    printf("Testing the libc implementation\n");
    srand(seed);
    start = clock();
    for(i = 0; i < 300000000; i ++) (void) rand();
    stop = clock();

    printf("Time elapsed = ");
    printf("%8.3f", (double)( stop - start ) / CLOCKS_PER_SEC);
    printf(" s\n");

    /*printf("Testing the Mersenne Twister thread safe implementation\n");
    r = random_initr(seed);
    start = clock();
    for(i = 0; i < 300000000; i ++) j = random_int32r(r);
    stop = clock();
    random_finir(r);

    printf("Time elapsed = ");
    printf("%8.3f", (double)( stop - start ) / CLOCKS_PER_SEC);
    printf(" s\n");*/

    exit(EXIT_SUCCESS);
}
