#include "../util/m_util_vfprintf.h"

/* gcc -g -Wall -std=c99 -posix -pedantic -O2 ../util/m_util_vfprintf.c ../util/m_util_dtoa.c ../util/m_util_float.c vfprintf.c -o vfprintf */

/* winegcc -mno-cygwin -I../ports/libpthread-win32/include -g -Wall -std=c99 -posix -pedantic -O2 ../util/m_util_vfprintf.c ../util/m_util_dtoa.c ../util/m_util_float.c vfprintf.c -o vfprintf */


int main(void)
{
    char buffer[BUFSIZ];

    memset(buffer, 0, sizeof(buffer));

    /* standard printf() conversions */
    printf("Wrote %i bytes:\n",
    m_snprintf(buffer, BUFSIZ, "%i 0x%x %p %s %f %e\n", 32, 0xDEADBEEF, & buffer, "test", 1337.1111, 1443.13456789));
    printf("%s\n", buffer);

    memset(buffer, 0, sizeof(buffer));

    /* little endian unaligned write */
    printf("Wrote %i bytes:\n", m_snprintf(buffer, BUFSIZ, "%2bbTu", 0xDEADBEEF));
    printf("0x%x\n", *((unsigned short *) buffer));
    printf("Wrote %i bytes:\n", m_snprintf(buffer + 2, BUFSIZ, "%2bbtu", 0xDEADBEEF));
    printf("0x%x\n", *((unsigned short *) buffer + 1));

    memset(buffer, 0, sizeof(buffer));

    /* big endian aligned write */
    printf("Wrote %i bytes:\n", m_snprintf(buffer, BUFSIZ, "%2bBTau", 0xDEADBEEF));
    printf("0x%x\n", *((unsigned int *) buffer));
    printf("Wrote %i bytes:\n", m_snprintf(buffer, BUFSIZ, "%2bBtau", 0xDEADBEEF));
    printf("0x%x\n", *((unsigned int *) buffer));

    /* system endianness double and float */
    printf("Wrote %i bytes:\n", m_snprintf(buffer, BUFSIZ, "%bf", 1337.1111));
    printf("%f\n", *((float *) buffer));
    printf("Wrote %i bytes:\n", m_snprintf(buffer, BUFSIZ, "%bg", 1337.1111));
    printf("%f\n", *((double *) buffer));

    exit(EXIT_SUCCESS);
}
